#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
ll matrica[1510][1510];
ll stepeni[35];
int main()
{
    int n, m;
    cin>>n>>m;
    for(int i=0; i<n; i++)
        for(int j=0; j<m; j++)cin>>matrica[i][j];
    if(n==1)
    {
        bool check=false;
        ll cnt=0;
        while(!check)
        {
            check=true;
            for(int i=0; i<m; i++)
            {
                stepeni[cnt]+=matrica[0][i]%2;
                matrica[0][i]/=2;
                if(matrica[0][i]>0)check=false;
            }
            stepeni[cnt]=min(stepeni[cnt], m-stepeni[cnt]);
            cnt++;
        }
        ll s2=1, rez=0;
        for(int i=0; i<=cnt; i++)
        {
            rez+=s2*stepeni[i];
            s2*=2;
        }
        cout<<rez;
    }
    return 0;
}